// file: PairC.java
// author: Bob Muller
// date: February 23, 2014
//
// This is an implementation of the PAIR ADT for problem 2 for the 
// S14 midterm exam.
//
import java.util.*;

public class PairC<S extends Comparable<S>, T extends Comparable<T>> implements Pair<S, T> {
    private S left;
    private T right;

    public PairC(S left, T right) {
        this.left = left;
        this.right = right;
    }

    public S getLeft()  { return this.left; }
    public T getRight() { return this.right; }

    public String toString() {
        String 
            leftString = this.getLeft().toString(),
            rightString = this.getRight().toString();
        return "(" + leftString + ", " + rightString + ")";
    }

    public Pair<T, S> swap() {
        return new PairC<T,S>(this.getRight(), this.getLeft());
    }

    public int compareTo(Pair<S, T> other) {
        return this.getLeft().compareTo(other.getLeft());
    } 
}